## nodejs 10.21.0~dfsg

=== Makefile ===
-include config.mk

BUILDTYPE ?= Release
PYTHON ?= python
DESTDIR ?=
SIGN ?=
PREFIX ?= /usr/local
FLAKY_TESTS ?= run
TEST_CI_ARGS ?=
STAGINGSERVER ?= node-www
LOGLEVEL ?= silent
OSTYPE := $(shell uname -s | tr '[A-Z]' '[a-z]')
COVTESTS ?= test-cov
GTEST_FILTER ?= "*"
GNUMAKEFLAGS += --no-print-directory
GCOV ?= gcov
PWD = $(CURDIR)

ifdef JOBS
  PARALLEL_ARGS = -j $(JOBS)
else
  PARALLEL_ARGS = -J
endif

ifdef ENABLE_V8_TAP
  TAP_V8 := --junitout $(PWD)/v8-tap.xml
  TAP_V8_INTL := --junitout $(PWD)/v8-intl-tap.xml
  TAP_V8_BENCHMARKS := --junitout $(PWD)/v8-benchmarks-tap.xml
endif

V8_TEST_OPTIONS = $(V8_EXTRA_TEST_OPTIONS)
ifdef DISABLE_V8_I18N
  V8_BUILD_OPTIONS += i18nsupport=off
endif

ifeq ($(OSTYPE), darwin)
  GCOV = xcrun llvm-cov gcov
endif

BUILDTYPE_LOWER := $(shell echo $(BUILDTYPE) | tr '[A-Z]' '[a-z]')

# Determine EXEEXT
EXEEXT := $(shell $(PYTHON) -c \
		"import sys; print('.exe' if sys.platform == 'win32' else '')")

NODE_EXE = node$(EXEEXT)
NODE ?= ./$(NODE_EXE)
NODE_G_EXE = node_g$(EXEEXT)
NPM ?= ./deps/npm/bin/npm-cli.js

# Flags for packaging.
BUILD_DOWNLOAD_FLAGS ?= --download=all
BUILD_INTL_FLAGS ?= --with-intl=small-icu
BUILD_RELEASE_FLAGS ?= $(BUILD_DOWNLOAD_FLAGS) $(BUILD_INTL_FLAGS)

# Default to verbose builds.
# To do quiet/pretty builds, run `make V=` to set V to an empty string,
# or set the V environment variable to an empty string.
V ?= 1

# Use -e to double check in case it's a broken link
# Use $(PWD) so we can cd to anywhere before calling this
available-node = \
  if [ -x $(PWD)/$(NODE) ] && [ -e $(PWD)/$(NODE) ]; then \
		$(PWD)/$(NODE) $(1); \
	elif [ -x `which node` ] && [ -e `which node` ] && [ `which node` ]; then \
		`which node` $(1); \
	else \
		echo "No available node, cannot run \"node $(1)\""; \
		exit 1; \
	fi;

.PHONY: all
# BUILDTYPE=Debug builds both release and debug builds. If you want to compile
# just the debug build, run `make -C out BUILDTYPE=Debug` instead.
ifeq ($(BUILDTYPE),Release)
all: $(NODE_EXE) ## Default target, builds node in out/Release/node.
else
all: $(NODE_EXE) $(NODE_G_EXE)
endif

.PHONY: help
# To add a target to the help, add a double comment (##) on the target line.
help: ## Print help for targets with comments.
	@printf "For more targets and info see the comments in the Makefile.\n\n"
	@grep -E '^[a-zA-Z0-9._-]+:.*?## .*$$' Makefile | sort | \
		awk 'BEGIN {FS = ":.*?## "}; {printf "\033[36m%-15s\033[0m %s\n", $$1, $$2}'

# The .PHONY is needed to ensure that we recursively use the out/Makefile
# to check for changes.
.PHONY: $(NODE_EXE) $(NODE_G_EXE)

# The -r/-L check stops it recreating the link if it is already in place,
# otherwise $(NODE_EXE) being a .PHONY target means it is always re-run.
# Without the check there is a race condition between the link being deleted
# and recreated which can break the addons build when running test-ci
# See comments on the build-addons target for some more info
$(NODE_EXE): config.gypi out/Makefile
	$(MAKE) -C out BUILDTYPE=Release V=$(V)
	if [ ! -r $@ -o ! -L $@ ]; then ln -fs out/Release/$(NODE_EXE) $@; fi

$(NODE_G_EXE): config.gypi out/Makefile
	$(MAKE) -C out BUILDTYPE=Debug V=$(V)
	if [ ! -r $@ -o ! -L $@ ]; then ln -fs out/Debug/$(NODE_EXE) $@; fi

CODE_CACHE_DIR ?= out/$(BUILDTYPE)/obj/gen
CODE_CACHE_FILE ?= $(CODE_CACHE_DIR)/node_code_cache.cc

ifeq ($(BUILDTYPE),Debug)
CONFIG_FLAGS += --debug
endif
.PHONY: with-code-cache
with-code-cache:
	@echo $(CONFIG_FLAGS)
	$(PYTHON) ./configure $(CONFIG_FLAGS)
	$(MAKE)
	mkdir -p $(CODE_CACHE_DIR)
	out/$(BUILDTYPE)/$(NODE_EXE) --expose-internals tools/generate_code_cache.js $(CODE_CACHE_FILE)
	$(PYTHON) ./configure --code-cache-path $(CODE_CACHE_FILE) $(CONFIG_FLAGS)
	$(MAKE)

.PHONY: test-code-cache
test-code-cache: with-code-cache
	$(PYTHON) tools/test.py $(PARALLEL_ARGS) --mode=$(BUILDTYPE_LOWER) code-cache

out/Makefile: common.gypi deps/uv/uv.gyp deps/http_parser/http_parser.gyp \
              deps/zlib/zlib.gyp deps/v8/gypfiles/toolchain.gypi \
              deps/v8/gypfiles/features.gypi deps/v8/gypfiles/v8.gyp node.gyp \
              config.gypi
	$(PYTHON) tools/gyp_node.py -f make

config.gypi: configure configure.py
	@if [ -x config.status ]; then \
		./config.status; \
	else \
		echo Missing or stale $@, please run ./$<; \
		exit 1; \
	fi

.PHONY: install
install: all ## Installs node into $PREFIX (default=/usr/local).
	$(PYTHON) tools/install.py $@ '$(DESTDIR)' '$(PREFIX)'

.PHONY: uninstall
uninstall: ## Uninstalls node from $PREFIX (default=/usr/local).
	$(PYTHON) tools/install.py $@ '$(DESTDIR)' '$(PREFIX)'

.PHONY: clean
clean: ## Remove build artifacts.
	$(RM) -r out/Makefile $(NODE_EXE) $(NODE_G_EXE) out/$(BUILDTYPE)/$(NODE_EXE) \
		out/$(BUILDTYPE)/node.exp
	@if [ -d out ]; then find out/ -name '*.o' -o -name '*.a' -o -name '*.d' | xargs $(RM) -r; fi
	$(RM) -r node_modules
	@if [ -d deps/icu ]; then echo deleting deps/icu; $(RM) -r deps/icu; fi
	$(RM) test.tap
	# Next one is legacy remove this at some point
	$(RM) -r test/tmp*
	$(RM) -r test/.tmp*
	$(MAKE) test-addons-clean
	$(MAKE) bench-addons-clean

.PHONY: distclean
distclean:
	$(RM) -r out
	$(RM) config.gypi icu_config.gypi config_fips.gypi
	$(RM) config.mk
	$(RM) -r $(NODE_EXE) $(NODE_G_EXE)
	$(RM) -r node_modules
	$(RM) -r deps/icu
	$(RM) -r deps/icu4c*.tgz deps/icu4c*.zip deps/icu-tmp
	$(RM) $(BINARYTAR).* $(TARBALL).*

.PHONY: check
check: test

.PHONY: coverage-clean
# Remove files generated by running coverage, put the non-instrumented lib back
# in place
coverage-clean:
	if [ -d lib_ ]; then $(RM) -r lib; mv lib_ lib; fi
	$(RM) -r node_modules
	$(RM) -r gcovr build
	$(RM) -r out/$(BUILDTYPE)/.coverage
	$(RM) -r .cov_tmp
	$(RM) out/$(BUILDTYPE)/obj.target/node/gen/*.gcda
	$(RM) out/$(BUILDTYPE)/obj.target/node/src/*.gcda
	$(RM) out/$(BUILDTYPE)/obj.target/node/src/tracing/*.gcda
	$(RM) out/$(BUILDTYPE)/obj.target/node/gen/*.gcno
	$(RM) out/$(BUILDTYPE)/obj.target/node/src/*.gcno
	$(RM) out/$(BUILDTYPE)/obj.target/node/src/tracing/*.gcno
	$(RM) out/$(BUILDTYPE)/obj.target/cctest/src/*.gcno
	$(RM) out/$(BUILDTYPE)/obj.target/cctest/test/cctest/*.gcno

.PHONY: coverage
# Build and test with code coverage reporting.  Leave the lib directory
# instrumented for any additional runs the user may want to make.
# For C++ coverage reporting, this needs to be run in conjunction with configure
#  --coverage.  html coverage reports will be created under coverage/
# Related CI job: node-test-commit-linux-coverage
coverage: coverage-test ## Run the tests and generate a coverage report.

.PHONY: coverage-build
coverage-build: all
	mkdir -p node_modules
	if [ ! -d node_modules/nyc ]; then \
		$(NODE) ./deps/npm install nyc@13 --no-save --no-package-lock; fi
	if [ ! -d gcovr ]; then git clone -b 3.4 --depth=1 \
		--single-branch https://github.com/gcovr/gcovr.git; fi
	if [ ! -d build ]; then git clone --depth=1 \
		--single-branch https://github.com/nodejs/build.git; fi
	if [ ! -f gcovr/scripts/gcovr.orig ]; then \
		(cd gcovr && patch -N -p1 < \
		"$(CURDIR)/build/jenkins/scripts/coverage/gcovr-patches-3.4.diff"); fi
	if [ -d lib_ ]; then $(RM) -r lib; mv lib_ lib; fi
	mv lib lib_
	NODE_DEBUG=nyc $(NODE) ./node_modules/.bin/nyc instrument --extension .js \
		--extension .mjs --exit-on-error lib_/ lib/
	$(MAKE)

.PHONY: coverage-test
coverage-test: coverage-build
	$(RM) -r out/$(BUILDTYPE)/.coverage
	$(RM) -r .cov_tmp
	$(RM) out/$(BUILDTYPE)/obj.target/node/gen/*.gcda
	$(RM) out/$(BUILDTYPE)/obj.target/node/src/*.gcda
	$(RM) out/$(BUILDTYPE)/obj.target/node/src/tracing/*.gcda
	$(RM) out/$(BUILDTYPE)/obj.target/node_lib/gen/*.gcda
	$(RM) out/$(BUILDTYPE)/obj.target/node_lib/src/*.gcda
	$(RM) out/$(BUILDTYPE)/obj.target/node_lib/src/tracing/*.gcda
	-$(MAKE) $(COVTESTS)
	mv lib lib__
	mv lib_ lib
	mkdir -p coverage .cov_tmp
	$(NODE) ./node_modules/.bin/nyc merge 'out/Release/.coverage' \
		.cov_tmp/libcov.json
	(cd lib && .$(NODE) ../node_modules/.bin/nyc report \
		--temp-dir "$(CURDIR)/.cov_tmp" \
		--report-dir "$(CURDIR)/coverage" \
		--reporter html)
	-(cd out && "../gcovr/scripts/gcovr" --gcov-exclude='.*deps' \
		--gcov-exclude='.*usr' -v -r Release/obj.target \
		--html --html-detail -o ../coverage/cxxcoverage.html \
		--gcov-executable="$(GCOV)")
	mv lib lib_
	mv lib__ lib
	@echo -n "Javascript coverage %: "
	@grep -B1 Lines coverage/index.html | head -n1 \
		| sed 's/<[^>]*>//g'| sed 's/ //g'
	@echo -n "C++ coverage %: "
	@grep -A3 Lines coverage/cxxcoverage.html | grep style  \
		| sed 's/<[^>]*>//g'| sed 's/ //g'

.PHONY: cctest
# Runs the C++ tests using the built `cctest` executable.
cctest: all
	@out/$(BUILDTYPE)/$@ --gtest_filter=$(GTEST_FILTER)

.PHONY: list-gtests
list-gtests:
ifeq (,$(wildcard out/$(BUILDTYPE)/cctest))
	$(error Please run 'make cctest' first)
endif
	@out/$(BUILDTYPE)/cctest --gtest_list_tests

.PHONY: v8
# Related CI job: node-test-commit-v8-linux
# Rebuilds deps/v8 as a git tree, pulls its third-party dependencies, and
# builds it.
v8:
	tools/make-v8.sh $(V8_ARCH).$(BUILDTYPE_LOWER) $(V8_BUILD_OPTIONS)

.PHONY: jstest
jstest: build-addons build-addons-napi ## Runs addon tests and JS tests
	$(PYTHON) tools/test.py $(PARALLEL_ARGS) --mode=$(BUILDTYPE_LOWER) \
		--skip-tests=$(CI_SKIP_TESTS) \
		$(CI_JS_SUITES) \
		$(CI_NATIVE_SUITES)

.PHONY: test
# This does not run tests of third-party libraries inside deps.
test: all ## Runs default tests, linters, and builds docs.
	$(MAKE) -s test-doc
	$(MAKE) -s build-addons
	$(MAKE) -s build-addons-napi
	$(MAKE) -s cctest
	$(MAKE) -s jstest

.PHONY: test-only
test-only: all  ## For a quick test, does not run linter or build docs.
	$(MAKE) build-addons
	$(MAKE) build-addons-napi
	$(MAKE) cctest
	$(MAKE) jstest

# Used by `make coverage-test`
test-cov: all
	$(MAKE) build-addons
	$(MAKE) build-addons-napi
	# $(MAKE) cctest
	CI_SKIP_TESTS=core_line_numbers.js $(MAKE) jstest

test-parallel: all
	$(PYTHON) tools/test.py $(PARALLEL_ARGS) --mode=$(BUILDTYPE_LOWER) parallel

test-valgrind: all
	$(PYTHON) tools/test.py $(PARALLEL_ARGS) --mode=$(BUILDTYPE_LOWER) --valgrind sequential parallel message

test-check-deopts: all
	$(PYTHON) tools/test.py $(PARALLEL_ARGS) --mode=$(BUILDTYPE_LOWER) --check-deopts parallel sequential

benchmark/napi/function_call/build/$(BUILDTYPE)/binding.node: \
		benchmark/napi/function_call/napi_binding.c \
		benchmark/napi/function_call/binding.cc \
		benchmark/napi/function_call/binding.gyp | all
	$(NODE) deps/npm/node_modules/node-gyp/bin/node-gyp rebuild \
		--python="$(PYTHON)" \
		--directory="$(shell pwd)/benchmark/napi/function_call" \
		--nodedir="$(shell pwd)"

benchmark/napi/function_args/build/$(BUILDTYPE)/binding.node: \
		benchmark/napi/function_args/napi_binding.c \
		benchmark/napi/function_args/binding.cc \
		benchmark/napi/function_args/binding.gyp | all
	$(NODE) deps/npm/node_modules/node-gyp/bin/node-gyp rebuild \
		--python="$(PYTHON)" \
		--directory="$(shell pwd)/benchmark/napi/function_args" \
		--nodedir="$(shell pwd)"

DOCBUILDSTAMP_PREREQS = tools/doc/addon-verify.js doc/api/addons.md

ifeq ($(OSTYPE),aix)
DOCBUILDSTAMP_PREREQS := $(DOCBUILDSTAMP_PREREQS) out/$(BUILDTYPE)/node.exp
endif

node_use_openssl = $(call available-node,"-p" \
		   "process.versions.openssl != undefined")
test/addons/.docbuildstamp: $(DOCBUILDSTAMP_PREREQS) tools/doc/node_modules
	@if [ "$(shell $(node_use_openssl))" != "true" ]; then \
		echo "Skipping .docbuildstamp (no crypto)"; \
	else \
		$(RM) -r test/addons/??_*/; \
		[ -x $(NODE) ] && $(NODE) $< || node $< ; \
		touch $@; \
	fi

ADDONS_BINDING_GYPS := \
	$(filter-out test/addons/??_*/binding.gyp, \
		$(wildcard test/addons/*/binding.gyp))

ADDONS_BINDING_SOURCES := \
	$(filter-out test/addons/??_*/*.cc, $(wildcard test/addons/*/*.cc)) \
	$(filter-out test/addons/??_*/*.h, $(wildcard test/addons/*/*.h))

ADDONS_PREREQS := config.gypi \
	deps/npm/node_modules/node-gyp/package.json tools/build-addons.js \
	deps/uv/include/*.h deps/v8/include/*.h \

=== debian/changelog ===
nodejs (10.21.0~dfsg-1~deb10u1) unstable; urgency=medium

  * update

 -- Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>  Mon, 11 Jan 2021 09:23:01 +0800

nodejs (10.21.0~dfsg-1~deb10u1) buster-security; urgency=medium

  * New upstream version 10.21.0~dfsg. Closes: #962145.
  * Security fixes:
    + CVE-2020-11080
    + CVE-2020-8172
    + CVE-2020-8174

 -- Jérémy Lal <kapouer@melix.org>  Thu, 04 Jun 2020 02:35:16 +0200

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-pie

# This needs to run before inclusion of CDBS snippets
debian/control:: debian/control.in debian/watch
DEB_PHONY_RULES += debian/control.in debian/watch
debian/control.in::
	sed $(foreach re,ABI ARCHS BRANCH,-e 's/__$(re)__/$($(re))/g') \
		< debian/control.in.in > debian/control.in

debian/watch::
	sed $(foreach re,BRANCH,-e 's/__$(re)__/$($(re))/g') \
		< debian/watch.in > debian/watch

include /usr/share/cdbs/1/rules/utils.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/autotools.mk

# source equivalent of nodejs -e 'console.log(process.versions.modules)'
ABI = $(shell awk '/^\#define NODE_MODULE_VERSION/ {print $$3}' src/node_version.h)

# archs
ARCHS := amd64 arm64 armhf i386 kfreebsd-i386 kfreebsd-amd64 mips mips64el mips64r6el mipsel ppc64 ppc64el s390x

# branch
BRANCH := $(word 1, $(subst .,$(space), $(DEB_UPSTREAM_VERSION)))

# Build-depend unversioned on debhelper
#  TODO: Drop when adopted in cdbs
CDBS_BUILD_DEPENDS_rules_debhelper_v9 = debhelper (>=9.20160114)

# Do not install licensecheck please
CDBS_BUILD_DEPENDS_rules_utils_copyright-check =

# Needed by upstream build
#  * recent gyp needed to build using flock
bdeps = pkg-config, bash-completion, libkvm-dev [kfreebsd-any], gyp (>= 0.1~svn1773)
bdeps +=, openssl (>= 1.1.1~)
bdeps +=, zlib1g-dev
bdeps +=, libicu-dev
bdeps +=, libc-ares-dev (>= 1.14~)
# bdeps +=, libnghttp2-dev (>= 1.34.0~)
# bdeps +=, libhttp-parser-dev (>= 2.8~)
bdeps +=, libbrotli-dev

# Needed by dev
devdeps = libssl-dev (>= 1.1.1~)
devdeps +=, libuv1-dev (>= 1.20.0~)

# Needed for tests
bdeps +=, curl, procps,
bdeps +=, node-acorn
bdeps +=, ca-certificates
bdeps +=, python

CDBS_BUILD_DEPENDS +=, $(bdeps), $(deps), $(devdeps)
CDBS_DEPENDS_libnode-dev = $(devdeps)

CDBS_RECOMMENDS_nodejs = ca-certificates
CDBS_BREAKS_libnode-dev = nodejs-dev (<< 10.0.0~dfsg1-3), libnode64-dev
CDBS_BREAKS_libnode$(ABI) = node-modern-syslog (<< 1.1.4-2)
CDBS_REPLACES_libnode-dev = nodejs-dev (<< 10.0.0~dfsg1-3), libnode64-dev, libv8-dev
CDBS_PROVIDES_libnode-dev = libv8-dev
CDBS_CONFLICTS_libnode-dev = libv8-dev (<= 3.14.5.8-11)
LANG=C
export LANG
DEB_CONFIGURE_NORMAL_ARGS =
DEB_CONFIGURE_EXTRA_FLAGS = \
--without-npm \
--without-snapshot \
--shared \
--shared-zlib \
--shared-cares \
--shared-brotli \
--with-intl=system-icu \
--prefix=/usr \
--openssl-use-def-ca-store \
--arch-triplet=$(DEB_HOST_MULTIARCH) \
--node-relative-path="lib/$(DEB_HOST_MULTIARCH)/nodejs:share/nodejs:lib/nodejs" \
--shared-libuv

DEB_CONFIGURE_EXTRA_FLAGS += --shared-openssl

# map HOST ARCH AND OS, and if unknown let upstream guess

# ia32 x64 x32 arm arm64 mips mipsel mips64el x87 ppc ppc64
destCpu =
destCpu := $(or $(destCpu),$(if $(filter i386,$(DEB_HOST_ARCH)),ia32))
destCpu := $(or $(destCpu),$(if $(filter x32,$(DEB_HOST_ARCH)),x32))
destCpu := $(or $(destCpu),$(if $(filter kfreebsd-i386,$(DEB_HOST_ARCH)),ia32))
destCpu := $(or $(destCpu),$(if $(filter hurd-i386,$(DEB_HOST_ARCH)),ia32))
destCpu := $(or $(destCpu),$(if $(filter amd64,$(DEB_HOST_ARCH)),x64))
destCpu := $(or $(destCpu),$(if $(filter kfreebsd-amd64,$(DEB_HOST_ARCH)),x64))
destCpu := $(or $(destCpu),$(if $(filter armel,$(DEB_HOST_ARCH)),unsupported))
destCpu := $(or $(destCpu),$(if $(filter armhf,$(DEB_HOST_ARCH)),arm))
destCpu := $(or $(destCpu),$(if $(filter aarch64,$(DEB_HOST_ARCH)),arm64))
destCpu := $(or $(destCpu),$(if $(filter mipsel,$(DEB_HOST_ARCH)),mipsel))
destCpu := $(or $(destCpu),$(if $(filter mips64el,$(DEB_HOST_ARCH)),mips64el))
destCpu := $(or $(destCpu),$(if $(filter mips64r6el,$(DEB_HOST_ARCH)),mips64el))
destCpu := $(or $(destCpu),$(if $(filter mips,$(DEB_HOST_ARCH)),mips))
destCpu := $(or $(destCpu),$(if $(filter powerpc,$(DEB_HOST_ARCH)),unsupported))
destCpu := $(or $(destCpu),$(if $(filter ppc64,$(DEB_HOST_ARCH)),ppc64))
destCpu := $(or $(destCpu),$(if $(filter s390x,$(DEB_HOST_ARCH)),s390x))

# solaris freebsd openbsd linux
destOs =
destOs := $(or $(destOs),$(if $(filter linux,$(DEB_HOST_ARCH_OS)),linux))
destOs := $(or $(destOs),$(if $(filter kfreebsd,$(DEB_HOST_ARCH_OS)),freebsd))

ifneq (, $(destOs))
DEB_CONFIGURE_EXTRA_FLAGS += --dest-os=$(destOs)
endif
ifeq (unsupported, $(destCpu))
$(error "nodejs cannot run on $(DEB_HOST_ARCH), please consult maintainers")
endif
ifneq (, $(destCpu))
DEB_CONFIGURE_EXTRA_FLAGS += --dest-cpu=$(destCpu)
endif

ifeq (freebsd, $(destOs))
LDFLAGS += -lbsd
endif

# mips and fpu
# https://github.com/paul99/v8m-rb/issues/192
# https://bugs.debian.org/800410
# mips and big binaries
# http://gcc.gnu.org/wiki/DebugFission
# https://bugs.debian.org/829139

# use r2, which is the supported variant for these architectures
# https://lists.debian.org/debian-mips/2016/07/msg00000.html
ifeq (mipsel, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-mips-arch-variant=r2 --with-mips-fpu-mode=fpxx
CFLAGS += -gsplit-dwarf
CPPFLAGS += -gsplit-dwarf
endif
ifeq (mips, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-mips-arch-variant=r2 --with-mips-fpu-mode=fpxx
CFLAGS += -gsplit-dwarf
CPPFLAGS += -gsplit-dwarf
endif

# mips32r1 or greater, detected at runtime
ifeq (mips64el, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-mips-arch-variant=rx --with-mips-fpu-mode=fp64
endif
ifeq (mips64r6el, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-mips-arch-variant=rx --with-mips-fpu-mode=fp64
endif

ifeq (armel, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-float-abi=softfp
ifeq ($(shell dpkg-vendor --is ubuntu && echo true),true)
# Ubuntu targets armv7+ with VFP and thumb2 support by default for armel
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfpv3
else
# debian defaults
# v8 does not support < armv5
CXXFLAGS += -march=armv5t
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfp
endif
endif

ifeq (armhf, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-float-abi=hard
ifeq ($(shell dpkg-vendor --derives-from raspbian && echo true),true)
# enable vfp, disable armv7
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfp
else
# enable armv7 vfpv3
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfpv3
endif
endif

DEB_DESTDIR = $(CURDIR)/debian/tmp
DEB_MAKE_CLEAN_TARGET = clean
# avoid troubles, never run tests with multiple jobs
export JOBS = 1
DEB_MAKE_BUILD_TARGET = build

#  relax regression tests when targeted experimental suite
export HOME = $(CURDIR)/tmp
export FLAKY_TESTS = dontcare
export TEST_CI_ARGS = --arch=$(destCpu) --timeout=3000
export CI_JS_SUITES = message parallel sequential
export NODE_TEST_DIR = $(CURDIR)/tmp
# needed for tests to avoid "ee key too small" errors
export OPENSSL_CONF = ./deps/openssl/openssl/apps/openssl.cnf
# keep in mind ./debian/rules check is also invoked by adt-run, see debian/tests/
exp-relax-check := $(if $(shell dpkg-parsechangelog | grep -x 'Distribution: \(experimental\|UNRELEASED\)'),-i)

ifeq (mips64el, $(DEB_HOST_ARCH))
DEB_MAKE_CHECK_TARGET = $(exp-relax-check)
else
DEB_MAKE_CHECK_TARGET = $(exp-relax-check) test-ci-js
endif

# build -fPIC
CFLAGS+=-fPIC
CPPFLAGS+=-fPIC
# hardening gyp
CFLAGS+=-g
CPPFLAGS+=-g
CXXFLAGS+=$(CPPFLAGS)
export CPPFLAGS
export CXXFLAGS
export CFLAGS
export LDFLAGS

# disable DNS requests during tests
export RES_OPTIONS = attempts:0

# properly clean files from build, test, python
clean::
	rm -f icu_config.gypi
	rm -rf test/addons/doc-*
	rm -f test/addons/.buildstamp
	rm -f test/addons/.docbuildstamp
	rm -rf test/addons/*/build
	rm -f config.gypi
	rm -f config.mk
	rm -f config.status
	rm -f test/fixtures/hello.txt
	rm -rf $(NODE_TEST_DIR)
	rm -f node_modules
	rm -rf tools/node_modules
	find . -name "*.pyc" -delete
	rm -rf out
	rm -rf deps/acorn/
	rm -f debian/libnode$(ABI).install
	rm -f debian/libnode-dev.links

# remove *.json files from documentation
binary-install/nodejs-doc::
	find debian/nodejs-doc/usr/share/doc/nodejs-doc -name *.json -delete

pre-build::
	ln -sTf /usr/lib/nodejs node_modules
	mkdir -p $(NODE_TEST_DIR)
	mkdir -p deps/acorn/dist/

## nodejs 10.24.0~dfsg

=== debian/changelog ===
nodejs (10.24.0~dfsg-1~deb10u4) buster-security; urgency=high

  * Non-maintainer upload by the LTS Security Team.
  * d/p/CVE-2022-32212.patch: Also backport upstream commit a1121b456c (unit
    tests).
  * Fix DNS unit tests which caused FTFBS in some build environments.
  * CVE-2023-30590: Documentation change for generateKeys() API function to
    align on the actual behavior, that is, only generate a private key if none
    has been set yet. (Closes: #1039990)
  * CVE-2023-46809: Marvin Attack vulnerability in the privateDecrypt() API of
    the crypto library.  This is a timing variant of the Bleichenbacher attack
    against PKCS#1 v1.5 padding.  The fix disables RSA_PKCS1_PADDING and
    includes a security revert flag that can be used to restore support (and
    the vulnerability). (Closes: #1064055)
  * CVE-2024-22025: Denial of Service by resource exhaustion in fetch() brotli
    decoding.

 -- Guilhem Moulin <guilhem@debian.org>  Tue, 26 Mar 2024 00:54:55 +0100

nodejs (10.24.0~dfsg-1~deb10u3) buster-security; urgency=high

  * Non-maintainer upload by the LTS Security Team.
  * CVE-2022-43548: OS Command Injection vulnerability due to insufficient
    `IsAllowedHost` check. Closes: #1023518.
  * CVE-2023-23920: Insecure loading of ICU data through ICU_DATA environment
    variable. Node.js now builds with ICU_NO_USER_DATA_OVERRIDE to avoid this.
    Closes: #1031834.

 -- Guilhem Moulin <guilhem@debian.org>  Sat, 25 Feb 2023 01:29:22 +0100

nodejs (10.24.0~dfsg-1~deb10u2) buster-security; urgency=high

  * Non-maintainer upload by the LTS Security Team.
  * Fix test suite failures (expired certificate; testing as root)
  * CVE-2021-22930, CVE-2021-22940: use after free attack where an
    attacker might be able to exploit the memory corruption, to change
    process behavior.
  * CVE-2021-22939: if the Node.js https API was used incorrectly and
    "undefined" was in passed for the "rejectUnauthorized" parameter, no
    error was returned and connections to servers with an expired
    certificate would have been accepted.
  * CVE-2022-21824: due to the formatting logic of the "console.table()"
    function it was not safe to allow user controlled input to be passed
    to the "properties" parameter while simultaneously passing a plain
    object with at least one property as the first parameter, which could
    be "__proto__".
  * CVE-2022-32212: OS Command Injection vulnerability due to an
    insufficient IsAllowedHost check that can easily be bypassed because
    IsIPAddress does not properly check if an IP address is invalid before
    making DBS requests allowing rebinding attacks.

 -- Sylvain Beucler <beuc@debian.org>  Tue, 04 Oct 2022 19:34:15 +0200

nodejs (10.24.0~dfsg-1~deb10u1) buster-security; urgency=medium

  * New upstream version 10.24.0~dfsg
    Fixed vulnerabilities:
    + CVE-2021-22883: HTTP2 'unknownProtocol' cause DoS
      by resource exhaustion
    + CVE-2021-22884: localhost6 DNS rebinding in --inspect

 -- Jérémy Lal <kapouer@melix.org>  Tue, 23 Feb 2021 14:48:02 +0100

nodejs (10.23.1~dfsg-1~deb10u1) buster-security; urgency=medium

  * New upstream version 10.23.1~dfsg. Closes: #979364.
    Fixed vulnerabilities:
    + CVE-2020-8265: use-after-free in TLSWrap (High)
    + CVE-2020-8287: HTTP Request Smuggling (Low)

 -- Jérémy Lal <kapouer@melix.org>  Tue, 05 Jan 2021 21:29:29 +0100

nodejs (10.22.1~dfsg-1~deb10u1) buster-security; urgency=medium

  * New upstream version 10.22.1~dfsg
    Vulnerabilities fixed:
    + CVE-2020-8252
      fs.realpath.native on may cause buffer overflow (Medium)

 -- Jérémy Lal <kapouer@melix.org>  Thu, 17 Sep 2020 18:05:41 +0200

=== debian/control ===
Source: nodejs
Section: javascript
Priority: optional
Maintainer: Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>
Uploaders: Jérémy Lal <kapouer@melix.org>,
 Jonas Smedegaard <dr@jones.dk>
Build-Depends: cdbs,
 debhelper (>=9.20160114),
 dh-buildinfo,
 pkg-config,
 bash-completion,
 libkvm-dev [kfreebsd-any],
 gyp (>= 0.1~svn1773),
 openssl (>= 1.1.1~),
 zlib1g-dev,
 libicu-dev,
 libc-ares-dev (>= 1.14~),
 libbrotli-dev,
 curl,
 procps,
 node-acorn,
 ca-certificates,
 python,
 libssl-dev (>= 1.1.1~),
 libuv1-dev (>= 1.20.0~)
Build-Depends-Indep: node-js-yaml,
 node-marked
Standards-Version: 4.3.0
Homepage: http://nodejs.org/
Vcs-Browser: https://salsa.debian.org/js-team/nodejs/tree/master-10.x
Vcs-Git: https://salsa.debian.org/js-team/nodejs.git -b master-10.x

Package: libnode-dev
Section: libdevel
Architecture: amd64 arm64 armhf i386 kfreebsd-i386 kfreebsd-amd64 mips mips64el mips64r6el mipsel ppc64 ppc64el s390x
Multi-Arch: same
Depends: ${cdbs:Depends},
 ${misc:Depends},
 libnode64 (= ${binary:Version})
Suggests: ${cdbs:Suggests}
Breaks: ${cdbs:Breaks}
Replaces: ${cdbs:Replaces}
Conflicts: ${cdbs:Conflicts}
Provides: ${cdbs:Provides}
Description: evented I/O for V8 javascript (development files)
 Node.js is a platform built on Chrome's JavaScript runtime for easily
 building fast, scalable network applications. Node.js uses an
 event-driven, non-blocking I/O model that makes it lightweight and
 efficient, perfect for data-intensive real-time applications that run
 across distributed devices.
 .
 This package provides development headers for libnode__ABI.

Package: nodejs
Architecture: amd64 arm64 armhf i386 kfreebsd-i386 kfreebsd-amd64 mips mips64el mips64r6el mipsel ppc64 ppc64el s390x
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libnode64 (= ${binary:Version})
Provides: ${cdbs:Provides}
Recommends: ${cdbs:Recommends},
 nodejs-doc
Suggests: npm
Replaces: nodejs-legacy
Conflicts: nodejs-legacy
Description: evented I/O for V8 javascript - runtime executable
 Node.js is a platform built on Chrome's JavaScript runtime for easily
 building fast, scalable network applications. Node.js uses an
 event-driven, non-blocking I/O model that makes it lightweight and
 efficient, perfect for data-intensive real-time applications that run
 across distributed devices.
 .
 Node.js is bundled with several useful libraries to handle server
 tasks:
 .
 System, Events, Standard I/O, Modules, Timers, Child Processes, POSIX,
 HTTP, Multipart Parsing, TCP, DNS, Assert, Path, URL, Query Strings.

Package: libnode64
Section: libs
Architecture: amd64 arm64 armhf i386 kfreebsd-i386 kfreebsd-amd64 mips mips64el mips64r6el mipsel ppc64 ppc64el s390x
Multi-Arch: same
Depends: ${shlibs:Depends},
 ${misc:Depends}
Provides: ${cdbs:Provides}
Recommends: ${cdbs:Recommends}
Breaks: ${cdbs:Breaks}
Replaces: nodejs-legacy
Conflicts: nodejs-legacy
Description: evented I/O for V8 javascript - runtime library
 Node.js is a platform built on Chrome's JavaScript runtime for easily
 building fast, scalable network applications. Node.js uses an
 event-driven, non-blocking I/O model that makes it lightweight and
 efficient, perfect for data-intensive real-time applications that run
 across distributed devices.
 .
 Node.js is bundled with several useful libraries to handle server
 tasks:
 .
 System, Events, Standard I/O, Modules, Timers, Child Processes, POSIX,
 HTTP, Multipart Parsing, TCP, DNS, Assert, Path, URL, Query Strings.
 .
 This package provides the dynamic library for Node.js.

Package: nodejs-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Provides: ${cdbs:Provides}
Recommends: ${cdbs:Recommends}, nodejs
Replaces: nodejs (<< 6.11.2~dfsg-3)
Conflicts: nodejs (<< 6.11.2~dfsg-3)
Description: API documentation for Node.js, the javascript platform
 Node.js is a platform built on Chrome's JavaScript runtime for easily
 building fast, scalable network applications. Node.js uses an
 event-driven, non-blocking I/O model that makes it lightweight and
 efficient, perfect for data-intensive real-time applications that run
 across distributed devices.
 .
 Node.js is bundled with several useful libraries to handle server
 tasks:
 .
 System, Events, Standard I/O, Modules, Timers, Child Processes, POSIX,
 HTTP, Multipart Parsing, TCP, DNS, Assert, Path, URL, Query Strings.
 .
 This package contains API documentation for Node.js.

=== debian/rules ===
--- 
+++ 
@@ -190,12 +190,7 @@
 export OPENSSL_CONF = ./deps/openssl/openssl/apps/openssl.cnf
 # keep in mind ./debian/rules check is also invoked by adt-run, see debian/tests/
 exp-relax-check := $(if $(shell dpkg-parsechangelog | grep -x 'Distribution: \(experimental\|UNRELEASED\)'),-i)
-
-ifeq (mips64el, $(DEB_HOST_ARCH))
-DEB_MAKE_CHECK_TARGET = $(exp-relax-check)
-else
 DEB_MAKE_CHECK_TARGET = $(exp-relax-check) test-ci-js
-endif
 
 # build -fPIC
 CFLAGS+=-fPIC
@@ -240,3 +235,6 @@
 	ln -sTf /usr/lib/nodejs node_modules
 	mkdir -p $(NODE_TEST_DIR)
 	mkdir -p deps/acorn/dist/
+	cp -rf /usr/lib/nodejs/acorn/dist/* deps/acorn/dist/
+
+common-install-arch::

## nodejs 12.1.0~dfsg

=== debian/changelog ===
nodejs (12.1.0~dfsg-1) experimental; urgency=medium

  * New upstream version 12.1.0~dfsg
  * Unapply all openssl 1.1.1 support patches
  * Unapply silencing of buffer deprecations warnings
  * Build using embedded uv until libuv1 1.28 is available
  * Build using node-acorn >= 6, node-acorn-walk
  * Update copyright file
  * dfsg-exclude tools/lint-md.js, dependencies to rebuild it
    are not available at the moment.

 -- Jérémy Lal <kapouer@melix.org>  Thu, 02 May 2019 11:32:28 +0200

=== debian/control ===
--- 
+++ 
@@ -15,20 +15,20 @@
  zlib1g-dev,
  libicu-dev,
  libc-ares-dev (>= 1.14~),
- libbrotli-dev,
+ libnghttp2-dev (>= 1.34.0~),
  curl,
  procps,
- node-acorn,
+ node-acorn (>= 6.0.0~),
+ node-acorn-walk,
  ca-certificates,
  python,
- libssl-dev (>= 1.1.1~),
- libuv1-dev (>= 1.20.0~)
+ libssl-dev (>= 1.1.1~)
 Build-Depends-Indep: node-js-yaml,
  node-marked
 Standards-Version: 4.3.0
 Homepage: http://nodejs.org/
-Vcs-Browser: https://salsa.debian.org/js-team/nodejs/tree/master-10.x
-Vcs-Git: https://salsa.debian.org/js-team/nodejs.git -b master-10.x
+Vcs-Browser: https://salsa.debian.org/js-team/nodejs/tree/master-12.x
+Vcs-Git: https://salsa.debian.org/js-team/nodejs.git -b master-12.x
 
 Package: libnode-dev
 Section: libdevel
@@ -36,7 +36,7 @@
 Multi-Arch: same
 Depends: ${cdbs:Depends},
  ${misc:Depends},
- libnode64 (= ${binary:Version})
+ libnode72 (= ${binary:Version})
 Suggests: ${cdbs:Suggests}
 Breaks: ${cdbs:Breaks}
 Replaces: ${cdbs:Replaces}
@@ -57,7 +57,7 @@
 Depends:
  ${shlibs:Depends},
  ${misc:Depends},
- libnode64 (= ${binary:Version})
+ libnode72 (= ${binary:Version})
 Provides: ${cdbs:Provides}
 Recommends: ${cdbs:Recommends},
  nodejs-doc
@@ -77,7 +77,7 @@
  System, Events, Standard I/O, Modules, Timers, Child Processes, POSIX,
  HTTP, Multipart Parsing, TCP, DNS, Assert, Path, URL, Query Strings.
 
-Package: libnode64
+Package: libnode72
 Section: libs
 Architecture: amd64 arm64 armhf i386 kfreebsd-i386 kfreebsd-amd64 mips mips64el mips64r6el mipsel ppc64 ppc64el s390x
 Multi-Arch: same

=== debian/rules ===
--- 
+++ 
@@ -40,17 +40,17 @@
 bdeps +=, zlib1g-dev
 bdeps +=, libicu-dev
 bdeps +=, libc-ares-dev (>= 1.14~)
-# bdeps +=, libnghttp2-dev (>= 1.34.0~)
+bdeps +=, libnghttp2-dev (>= 1.34.0~)
 # bdeps +=, libhttp-parser-dev (>= 2.8~)
-bdeps +=, libbrotli-dev
 
 # Needed by dev
 devdeps = libssl-dev (>= 1.1.1~)
-devdeps +=, libuv1-dev (>= 1.20.0~)
+# devdeps +=, libuv1-dev (>= 1.20.0~)
 
 # Needed for tests
 bdeps +=, curl, procps,
-bdeps +=, node-acorn
+bdeps +=, node-acorn (>= 6.0.0~)
+bdeps +=, node-acorn-walk
 bdeps +=, ca-certificates
 bdeps +=, python
 
@@ -72,13 +72,13 @@
 --shared \
 --shared-zlib \
 --shared-cares \
---shared-brotli \
+--shared-nghttp2 \
 --with-intl=system-icu \
 --prefix=/usr \
 --openssl-use-def-ca-store \
 --arch-triplet=$(DEB_HOST_MULTIARCH) \
---node-relative-path="lib/$(DEB_HOST_MULTIARCH)/nodejs:share/nodejs:lib/nodejs" \
---shared-libuv
+--node-relative-path="lib/$(DEB_HOST_MULTIARCH)/nodejs:share/nodejs:lib/nodejs"
+#--shared-libuv
 
 DEB_CONFIGURE_EXTRA_FLAGS += --shared-openssl
 
@@ -133,11 +133,13 @@
 # https://lists.debian.org/debian-mips/2016/07/msg00000.html
 ifeq (mipsel, $(DEB_HOST_ARCH))
 DEB_CONFIGURE_EXTRA_FLAGS += --with-mips-arch-variant=r2 --with-mips-fpu-mode=fpxx
+LDFLAGS += -latomic
 CFLAGS += -gsplit-dwarf
 CPPFLAGS += -gsplit-dwarf
 endif
 ifeq (mips, $(DEB_HOST_ARCH))
 DEB_CONFIGURE_EXTRA_FLAGS += --with-mips-arch-variant=r2 --with-mips-fpu-mode=fpxx
+LDFLAGS += -latomic
 CFLAGS += -gsplit-dwarf
 CPPFLAGS += -gsplit-dwarf
 endif
@@ -176,8 +178,14 @@
 
 DEB_DESTDIR = $(CURDIR)/debian/tmp
 DEB_MAKE_CLEAN_TARGET = clean
-# avoid troubles, never run tests with multiple jobs
-export JOBS = 1
+ifeq ($(DEB_PARALLEL_JOBS),)
+JOBS := 1
+else ifeq ($(SCHROOT_USER),"buildd")
+JOBS := 1
+else
+JOBS := $(DEB_PARALLEL_JOBS)
+endif
+export JOBS
 DEB_MAKE_BUILD_TARGET = build
 
 #  relax regression tests when targeted experimental suite
@@ -233,8 +241,3 @@
 
 pre-build::
 	ln -sTf /usr/lib/nodejs node_modules
-	mkdir -p $(NODE_TEST_DIR)
-	mkdir -p deps/acorn/dist/
-	cp -rf /usr/lib/nodejs/acorn/dist/* deps/acorn/dist/
-
-common-install-arch::

=== debian/watch ===
version=3
opts=downloadurlmangle=s/.*v(.*)\//https\:\/\/nodejs\.org\/dist\/v$1\/node\-v$1\.tar\.gz/,\
filenamemangle=s/.*v(.*)\/$/nodejs-$1\.tar\.gz/,\
dversionmangle=s/~dfsg\d*$//,\
repacksuffix=~dfsg \
https://nodejs.org/dist v(12\.\d+\.\d+)/
